# -*- coding: utf-8 -*-
#
# Copyright (C) 2006-2007 Edgewall Software
# All rights reserved.
#
# This software is licensed as described in the file COPYING, which
# you should have received as part of this distribution. The terms
# are also available at http://posterity.edgewall.org/wiki/License.
#
# This software consists of voluntary contributions made by many
# individuals. For the exact contribution history, see the revision
# history and logs, available at http://posterity.edgewall.org/log/.

from paste.registry import StackedObjectProxy
from elixir import *

SCHEMA_VERSION = 1

transaction = StackedObjectProxy()

class System(Entity):
    """Table for storage of system wide settings.

    This table is for example used to keep track of the SQL schema version
    (name='schema_version')
    """
    has_field('name', Unicode(100), primary_key=True)
    has_field('value', Unicode)
    using_table_options(mysql_engine='InnoDB')
    using_options(tablename='system')


def init_db():
    """Initializes an empty database.
    
    This function creates and initializes the tables needed by posterity.
    """
    create_all()
    System(name='schema_version', value=str(SCHEMA_VERSION))
